<template>
  <div class="max-w-[800px] mx-auto p-8">
<!--    <pre>{{ meal }}</pre>-->
    <h1 class="text-4xl font-bold mb-5 text-orange-500">{{ meal.strMeal }}</h1>
    <img :src="meal.strMealThumb" :alt="meal.strMeal" class="max-w-[100%]">

    <div class="grid grid-cols-1 sm:grid-cols-3 text-lg py-2">
      <div>
        <strong class="font-bold">Category :</strong> {{ meal.strCategory }}
      </div>
      <div>
        <strong class="font-bold">Country :</strong> {{ meal.strArea }}
      </div>
      <div>
        <strong class="font-bold">Tags : </strong>{{ meal.strTags }}
      </div>
    </div>
    <div>
      <div :id="'truncatedText-' + index" class=" mx-auto pt-4" :class="{ 'line-clamp-3': !isTextTruncated(index) }">
        <p>
          {{ meal.strInstructions }}
        </p>
      </div>
      <button @click="toggleText(index)" class="bg-orange-500 text-black p-2 ml-44 my-4 rounded">
        {{ isTextTruncated(index) ? 'Show Less' : 'Show More' }}
      </button>
    </div>
    <div class="my-4 flex items-center justify-between">
      <YouTubeButton :href="meal.strYoutube">Go To YouTube</YouTubeButton>
      <OriginalSourceButton :href="meal.strSource">Original Source</OriginalSourceButton>
    </div>

    <div class="grid grid-cols-1 sm:grid-cols-2">
      <div>
        <h2 class="text-2xl font-semibold mb-2">Ingredients</h2>
        <ul>
          <template v-for="(element, index) of new Array(20)">
              <li v-if="meal[`strIngredient${index + 1}`]">
               {{ index + 1 }}. {{ meal[`strIngredient${index + 1}`] }}
              </li>
          </template>
        </ul>
      </div>
      <div>
        <h2 class="text-2xl font-semibold mb-2">Measures</h2>
        <ul>
          <template v-for="(element, index) of new Array(20)">
            <li v-if="meal[`strMeasure${index + 1}`]">
              {{ index + 1 }}. {{ meal[`strMeasure${index + 1}`] }}
            </li>
          </template>
        </ul>
      </div>
    </div>
  </div>
</template>

<script setup>
import {onMounted, ref} from "vue";
import {useRoute} from "vue-router";
import axiosClient from "@/axiosClient";
import YouTubeButton from "@/components/YouTubeButton.vue";
import OriginalSourceButton from "@/components/OriginalSourceButton.vue";

const route = useRoute()
const meal = ref({})
const textTruncated = ref(Array(0));

onMounted(() => {
  axiosClient.get(`lookup.php?i=${route.params.id}`)
    .then(({data}) => {
      meal.value = data.meals[0] || {}
    })
})

function toggleText(index) {
  textTruncated.value[index] = !textTruncated.value[index];
}

function isTextTruncated(index) {
  return textTruncated.value[index];
}
</script>

